﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Workflow.Activities;

namespace BlogMonitor
{
    public class BlogMonitor: IBlogMonitor
    {
        public event EventHandler<ExternalDataEventArgs> Unsubscribe;

        public void OnUnsubscribe(ExternalDataEventArgs args)
        {
            if (Unsubscribe != null)
            {
                Unsubscribe(null, args);
            }
        }

        public event EventHandler<FeedResultEventArgs> ResultsAvailable;

        public void SendNotification(Dictionary<string, FeedResult> results)
        {
            if (ResultsAvailable != null)
            {
                ResultsAvailable(this, new FeedResultEventArgs() { Results = results });
            }
        }
    }

    public class FeedResultEventArgs: EventArgs
    {
        public Dictionary<string, FeedResult> Results {get;set;}
    }
}
