﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

namespace BugWorkflow
{
    [Designer(typeof(BugActivityDesigner), typeof(IDesigner))]
    public partial class AssignToActivity : System.Workflow.ComponentModel.Activity
    {
        public BugReport BugReport
        {
            get { return (BugReport)GetValue(BugReportProperty); }
            set { SetValue(BugReportProperty, value); }
        }

        public static readonly DependencyProperty BugReportProperty =
            DependencyProperty.Register("BugReport", typeof(BugReport), typeof(AssignToActivity));

        public string UserToAssign
        {
            get { return (string)GetValue(UserToAssignProperty); }
            set { SetValue(UserToAssignProperty, value); }
        }

        public static readonly DependencyProperty UserToAssignProperty =
            DependencyProperty.Register("UserToAssign", typeof(string), typeof(AssignToActivity));


        public string RoleToAssign
        {
            get { return (string)GetValue(RoleToAssignProperty); }
            set { SetValue(RoleToAssignProperty, value); }
        }

        public static readonly DependencyProperty RoleToAssignProperty =
            DependencyProperty.Register("RoleToAssign", typeof(string), typeof(AssignToActivity));


        public AssignToActivity()
        {
            InitializeComponent();
        }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            this.BugReport.AssignedToRole = this.RoleToAssign;
            this.BugReport.AssignedToUser = this.UserToAssign;

            IBugWorkflow bugService = executionContext.GetService<IBugWorkflow>();
            bugService.AssignBugReport(new BugReportEventArgs(this.BugReport, this.WorkflowInstanceId));

            return ActivityExecutionStatus.Closed;
        }
    }
}
