﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CoffeeRulesUI
{
    /// <summary>
    /// Interaction logic for UserControl1.xaml
    /// </summary>
    public partial class CoffeeRulesPanel : UserControl, WorkflowSimulator.IWorkflowUI
    {
        public WorkflowSimulator.WorkflowDiagram WorkflowDiagram
        {
            get;
            set;
        }

        public CoffeeRulesPanel()
        {
            InitializeComponent();
        }

        private void btnOrder_Click(object sender, RoutedEventArgs e)
        {
            CoffeeRules.CoffeeSelection selection = new CoffeeRules.CoffeeSelection() 
            { CoffeeType = cboCoffeeType.Text, SizeOz = Int32.Parse(cboSize.Text), IsDecaf = chkDecaf.IsChecked.Value };
   

            Dictionary<string, object> initParameters = new Dictionary<string, object>()
                {
                    {"Selection", selection}
                };

            WorkflowDiagram.RunWorkflow(initParameters);

            WorkflowDiagram.WorkflowRuntime.WorkflowCompleted += (o, args) =>
            {
                cboCoffeeType.Dispatcher.Invoke((Action)(
                () =>
                {

                    CoffeeRules.CoffeeSelection finalSelection = args.OutputParameters["Selection"] as CoffeeRules.CoffeeSelection;

                    if (finalSelection.Error != null)
                    {
                        MessageBox.Show(finalSelection.Error, "A Problem With Your Order", MessageBoxButton.OK, MessageBoxImage.Error);
                    }
                    else
                    {
                        MessageBox.Show(string.Format("Order submitted for {0} {1} beans in the {2} oz size.",
                            finalSelection.SuggestedType,
                            finalSelection.IsDecaf ? "decaffeinated" : "fully caffeinated",
                            finalSelection.SizeOz),
                            "Your Order Selection", MessageBoxButton.OK, MessageBoxImage.Information);
                    }
                }
                ));
            };
        }
    }
}
