﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

namespace ConferenceRegistration
{
    public partial class HotelBookingActivity : System.Workflow.ComponentModel.Activity
    {

        public RegistrationInfo Registration
        {
            get { return (RegistrationInfo)GetValue(RegistrationProperty); }
            set { SetValue(RegistrationProperty, value); }
        }

        public static readonly DependencyProperty RegistrationProperty =
            DependencyProperty.Register("Registration", typeof(RegistrationInfo), typeof(HotelBookingActivity));


        public BookingResult Result
        {
            get { return (BookingResult)GetValue(ResultProperty); }
            set { SetValue(ResultProperty, value); }
        }

        public static readonly DependencyProperty ResultProperty =
            DependencyProperty.Register("Result", typeof(BookingResult), typeof(HotelBookingActivity));


        public HotelBookingActivity()
        {
            InitializeComponent();
        }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            Random rng = new Random();
            int randomInt = rng.Next(0, 3);

            if (randomInt > 0)
            {
                this.Result = BookingResult.Retry;  
            }
            else
            {
                this.Result = BookingResult.Success; 
            }

            return ActivityExecutionStatus.Closed;
        }
    }
}
