﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConferenceRegistration
{
    [Serializable()]
	public class RegistrationInfo
	{
        public Customer CustomerInfo { get; set; }
        public Billing BillingInfo {get;set;}
	}

    [Serializable()]
    public class Customer
    {
        public string Email { get; set; }
        public string FirstName { get; set; }
        public string LastName { get; set; }
    }

    [Serializable()]
    public class Address
    {
        public string Street1 { get; set; }
        public string Street2 { get; set; }
        public string City { get; set; }
        public string State { get; set; }
        public string Zip { get; set; }
        public string Country { get; set; }
        public string Phone { get; set; }
    }

    [Serializable()]
    public class Billing
    {
        public string NameOnCard { get; set; }
        public Address BillingAddress { get; set; }
        public string CreditCardNumber { get; set; }
        public string CreditCardSecurityCode { get; set; }
        public string ExpirationDate { get; set; }
        public string CardType { get; set; }
    }

    public enum BookingResult
    {
        Success,
        Retry,
        Failed
    }
}
