﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using WorkflowSimulator;

namespace ConferenceRegistration
{
    [WorkflowSimulationUI(LocalServiceType = "Default", UserInterfaceType = "ConferenceRegistration.ConferenceRegistrationPanel, ConferenceRegistrationUI")]
    public sealed partial class ConferenceRegistrationSequentialWorkflow : SequentialWorkflowActivity
    {
        public RegistrationInfo AttendeeRegistration
        {
            get { return (RegistrationInfo)GetValue(AttendeeRegistrationProperty); }
            set { SetValue(AttendeeRegistrationProperty, value); }
        }

        public static readonly DependencyProperty AttendeeRegistrationProperty =
            DependencyProperty.Register("AttendeeRegistration", typeof(RegistrationInfo), typeof(ConferenceRegistrationSequentialWorkflow));

        public BookingResult HotelBookingResult
        {
            get { return (BookingResult)GetValue(HotelBookingResultProperty); }
            set { SetValue(HotelBookingResultProperty, value); }
        }

        public static readonly DependencyProperty HotelBookingResultProperty =
            DependencyProperty.Register("HotelBookingResult", typeof(BookingResult), typeof(ConferenceRegistrationSequentialWorkflow));

        public ConferenceRegistrationSequentialWorkflow()
        {
            InitializeComponent();
        }

        protected override void InitializeProperties()
        {
            base.InitializeProperties();

            HotelBookingResult = BookingResult.Retry;
        }
    }

}
