﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Workflow.Activities;

namespace Crm
{
    public class CrmService: ICrmService
    {
        public event EventHandler<ExternalDataEventArgs> Deal;
        public event EventHandler<ExternalDataEventArgs> NoDeal;
        public event EventHandler<ExternalDataEventArgs> NoResponse;

        public void OnDeal(Guid instanceId)
        {
            if (Deal!= null)
            {
                Deal(null, new ExternalDataEventArgs(instanceId));
            }
        }

        public void OnNoDeal(Guid instanceId)
        {
            if (NoDeal != null)
            {
                NoDeal(null, new ExternalDataEventArgs(instanceId));
            }
        }

        public void OnNoResponse(Guid instanceId)
        {
            if (NoResponse != null)
            {
                NoResponse(null, new ExternalDataEventArgs(instanceId));
            }
        }
    }
}
