﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using WorkflowSimulator;

namespace Crm
{
    [WorkflowSimulationUI(LocalServiceType = "Crm.CrmService, CrmLocalService", UserInterfaceType = "Crm.CrmPanel, CrmUI")]
    public sealed partial class CrmSequentialWorkflow : SequentialWorkflowActivity
    {
        public SalesLead SalesLead
        {
            get { return (SalesLead)GetValue(SalesLeadProperty); }
            set { SetValue(SalesLeadProperty, value); }
        }

        public static readonly DependencyProperty SalesLeadProperty =
            DependencyProperty.Register("SalesLead", typeof(SalesLead), typeof(CrmSequentialWorkflow));


        public bool AllowUpdates
        {
            get { return (bool)GetValue(AllowUpdatesProperty); }
            set { SetValue(AllowUpdatesProperty, value); }
        }

        public static readonly DependencyProperty AllowUpdatesProperty =
            DependencyProperty.Register("AllowUpdates", typeof(bool), typeof(CrmSequentialWorkflow));


        public CrmSequentialWorkflow()
        {
            InitializeComponent();
        }

        private void AreUpdatesAllowed(object sender, ConditionalEventArgs e)
        {
            e.Result = this.AllowUpdates;
        }

    }

}
