﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using System.IO;

namespace ImageArchival
{
    public partial class ArchiveImageActivity : System.Workflow.ComponentModel.Activity
    {
        public string SourcePath
        {
            get { return (string)GetValue(SourcePathProperty); }
            set { SetValue(SourcePathProperty, value); }
        }

        public static readonly DependencyProperty SourcePathProperty =
            DependencyProperty.Register("SourcePath", typeof(string), typeof(ArchiveImageActivity));


        public string ArchivePath
        {
            get { return (string)GetValue(ArchivePathProperty); }
            set { SetValue(ArchivePathProperty, value); }
        }

        public static readonly DependencyProperty ArchivePathProperty =
            DependencyProperty.Register("ArchivePath", typeof(string), typeof(ArchiveImageActivity));

        public ArchiveImageActivity()
        {
            InitializeComponent();
        }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            File.Move(SourcePath, ArchivePath); 

            return ActivityExecutionStatus.Closed;
        }
    }
}
