﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using System.Data.SqlClient;

namespace ImageArchival
{
    public partial class ImageDetailsActivity : System.Workflow.ComponentModel.Activity
    {
        public int ImageDetailsId
        {
            get { return (int)GetValue(ImageDetailsIdProperty); }
            set { SetValue(ImageDetailsIdProperty, value); }
        }

        public static readonly DependencyProperty ImageDetailsIdProperty =
            DependencyProperty.Register("ImageDetailsId", typeof(int), typeof(ImageDetailsActivity));

        public int FileId
        {
            get { return (int)GetValue(FileIdProperty); }
            set { SetValue(FileIdProperty, value); }
        }

        public static readonly DependencyProperty FileIdProperty =
            DependencyProperty.Register("FileId", typeof(int), typeof(ImageDetailsActivity));

        public string Caption
        {
            get { return (string)GetValue(CaptionProperty); }
            set { SetValue(CaptionProperty, value); }
        }

        public static readonly DependencyProperty CaptionProperty =
            DependencyProperty.Register("Caption", typeof(string), typeof(ImageDetailsActivity));

        public string Description
        {
            get { return (string)GetValue(DescriptionProperty); }
            set { SetValue(DescriptionProperty, value); }
        }

        public static readonly DependencyProperty DescriptionProperty =
            DependencyProperty.Register("Description", typeof(string), typeof(ImageDetailsActivity));

        public string Username
        {
            get { return (string)GetValue(UsernameProperty); }
            set { SetValue(UsernameProperty, value); }
        }

        public static readonly DependencyProperty UsernameProperty =
            DependencyProperty.Register("Username", typeof(string), typeof(ImageDetailsActivity));

        public bool SimulateSqlError
        {
            get { return (bool)GetValue(SimulateSqlErrorProperty); }
            set { SetValue(SimulateSqlErrorProperty, value); }
        }

        public static readonly DependencyProperty SimulateSqlErrorProperty =
            DependencyProperty.Register("SimulateSqlError", typeof(bool), typeof(ImageDetailsActivity));

        private string ConnectionString
        {
            get
            {
                return System.Configuration.ConfigurationManager.ConnectionStrings["ImageArchival"].ConnectionString;
            }
        }

        public ImageDetailsActivity()
        {
            InitializeComponent();
        }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            using (SqlConnection con = new SqlConnection(this.ConnectionString))
            {
                con.Open();
                
                SqlCommand cmd = con.CreateCommand();
                cmd.CommandType = System.Data.CommandType.StoredProcedure;
                cmd.CommandText = "InsertDetails";
                cmd.Parameters.AddRange(new SqlParameter[]
                {
                    new SqlParameter("FileId", this.SimulateSqlError ? -1 : this.FileId),
                    new SqlParameter("Caption", this.Caption),
                    new SqlParameter("Description", this.Description),
                    new SqlParameter("Username", this.Username)
                });
                
                this.ImageDetailsId = Decimal.ToInt32((Decimal)cmd.ExecuteScalar());
            }

            return ActivityExecutionStatus.Closed;
        }
    }
}
