﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using System.Data.SqlClient;

namespace ImageArchival
{
    public partial class ImageMetadataActivity : System.Workflow.ComponentModel.Activity
    {
        public string FileName
        {
            get { return (string)GetValue(FileNameProperty); }
            set { SetValue(FileNameProperty, value); }
        }

        public static readonly DependencyProperty FileNameProperty =
            DependencyProperty.Register("FileName", typeof(string), typeof(ImageMetadataActivity));

        public string StoragePath
        {
            get { return (string)GetValue(StoragePathProperty); }
            set { SetValue(StoragePathProperty, value); }
        }

        public static readonly DependencyProperty StoragePathProperty =
            DependencyProperty.Register("StoragePath", typeof(string), typeof(ImageMetadataActivity));

        public DateTime FileDate
        {
            get { return (DateTime)GetValue(FileDateProperty); }
            set { SetValue(FileDateProperty, value); }
        }

        public static readonly DependencyProperty FileDateProperty =
            DependencyProperty.Register("FileDate", typeof(DateTime), typeof(ImageMetadataActivity));

        public long FileSize
        {
            get { return (long)GetValue(FileSizeProperty); }
            set { SetValue(FileSizeProperty, value); }
        }

        public static readonly DependencyProperty FileSizeProperty =
            DependencyProperty.Register("FileSize", typeof(long), typeof(ImageMetadataActivity));

        public int FileId
        {
            get { return (int)GetValue(FileIdProperty); }
            set { SetValue(FileIdProperty, value); }
        }

        public static readonly DependencyProperty FileIdProperty =
            DependencyProperty.Register("FileId", typeof(int), typeof(ImageMetadataActivity));



        private string ConnectionString
        {
            get
            {
                return System.Configuration.ConfigurationManager.ConnectionStrings["ImageArchival"].ConnectionString;
            }
        }

        public ImageMetadataActivity()
        {
            InitializeComponent();
        }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            using (SqlConnection con = new SqlConnection(this.ConnectionString))
            {
                con.Open();

                SqlCommand cmd = con.CreateCommand();
                cmd.CommandType = System.Data.CommandType.StoredProcedure;
                cmd.CommandText = "InsertMetadata";
                cmd.Parameters.AddRange(new SqlParameter[]
                {
                    new SqlParameter("FileName", this.FileName),
                    new SqlParameter("StoragePath", this.StoragePath),
                    new SqlParameter("FileDate", this.FileDate),
                    new SqlParameter("FileSize", this.FileSize)
                });

                this.FileId = Decimal.ToInt32((Decimal)cmd.ExecuteScalar());
            }

            return ActivityExecutionStatus.Closed;
        }
    }
}
