﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using System.Data.SqlClient;

namespace ImageArchival
{
    public partial class RemoveImageDataActivity : System.Workflow.ComponentModel.Activity
    {
        public int FileId
        {
            get { return (int)GetValue(FileIdProperty); }
            set { SetValue(FileIdProperty, value); }
        }

        public static readonly DependencyProperty FileIdProperty =
            DependencyProperty.Register("FileId", typeof(int), typeof(RemoveImageDataActivity));

        private string ConnectionString
        {
            get
            {
                return System.Configuration.ConfigurationManager.ConnectionStrings["ImageArchival"].ConnectionString;
            }
        }

        public RemoveImageDataActivity()
        {
            InitializeComponent();
        }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            using (SqlConnection con = new SqlConnection(this.ConnectionString))
            {
                con.Open();

                SqlCommand cmd = con.CreateCommand();
                cmd.CommandType = System.Data.CommandType.StoredProcedure;
                cmd.CommandText = "RemoveImage";
                cmd.Parameters.AddRange(new SqlParameter[]
                {
                    new SqlParameter("FileId", this.FileId)
                });

                cmd.ExecuteNonQuery();
            }

            return ActivityExecutionStatus.Closed;
        }
    }
}
