﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using WorkflowSimulator;

namespace ImageArchival
{
    [WorkflowSimulationUI(LocalServiceType = "Default", UserInterfaceType = "ImageArchival.ImageArchivalPanel, ImageArchivalUI")]
    public sealed partial class ImageArchivalStateMachineWorkflow : StateMachineWorkflowActivity
    {
        public string FileName
        {
            get { return (string)GetValue(FileNameProperty); }
            set { SetValue(FileNameProperty, value); }
        }

        public static readonly DependencyProperty FileNameProperty =
            DependencyProperty.Register("FileName", typeof(string), typeof(ImageArchivalStateMachineWorkflow));


        public string SourcePath
        {
            get { return (string)GetValue(SourcePathProperty); }
            set { SetValue(SourcePathProperty, value); }
        }

        public static readonly DependencyProperty SourcePathProperty =
            DependencyProperty.Register("SourcePath", typeof(string), typeof(ImageArchivalStateMachineWorkflow));



        public string ArchivePath
        {
            get { return (string)GetValue(ArchivePathProperty); }
            set { SetValue(ArchivePathProperty, value); }
        }

        public static readonly DependencyProperty ArchivePathProperty =
            DependencyProperty.Register("ArchivePath", typeof(string), typeof(ImageArchivalStateMachineWorkflow));



        public DateTime FileDate
        {
            get { return (DateTime)GetValue(FileDateProperty); }
            set { SetValue(FileDateProperty, value); }
        }

        public static readonly DependencyProperty FileDateProperty =
            DependencyProperty.Register("FileDate", typeof(DateTime), typeof(ImageArchivalStateMachineWorkflow));

        public long FileSize
        {
            get { return (long)GetValue(FileSizeProperty); }
            set { SetValue(FileSizeProperty, value); }
        }

        public static readonly DependencyProperty FileSizeProperty =
            DependencyProperty.Register("FileSize", typeof(long), typeof(ImageArchivalStateMachineWorkflow));

        public int FileId
        {
            get { return (int)GetValue(FileIdProperty); }
            set { SetValue(FileIdProperty, value); }
        }

        public static readonly DependencyProperty FileIdProperty =
            DependencyProperty.Register("FileId", typeof(int), typeof(ImageArchivalStateMachineWorkflow));

        public int ImageDetailsId
        {
            get { return (int)GetValue(ImageDetailsIdProperty); }
            set { SetValue(ImageDetailsIdProperty, value); }
        }

        public static readonly DependencyProperty ImageDetailsIdProperty =
            DependencyProperty.Register("ImageDetailsId", typeof(int), typeof(ImageArchivalStateMachineWorkflow));

        public string Caption
        {
            get { return (string)GetValue(CaptionProperty); }
            set { SetValue(CaptionProperty, value); }
        }

        public static readonly DependencyProperty CaptionProperty =
            DependencyProperty.Register("Caption", typeof(string), typeof(ImageArchivalStateMachineWorkflow));

        public string Description
        {
            get { return (string)GetValue(DescriptionProperty); }
            set { SetValue(DescriptionProperty, value); }
        }

        public static readonly DependencyProperty DescriptionProperty =
            DependencyProperty.Register("Description", typeof(string), typeof(ImageArchivalStateMachineWorkflow));

        public string Username
        {
            get { return (string)GetValue(UsernameProperty); }
            set { SetValue(UsernameProperty, value); }
        }

        public static readonly DependencyProperty UsernameProperty =
            DependencyProperty.Register("Username", typeof(string), typeof(ImageArchivalStateMachineWorkflow));

        public bool SimulateSqlError
        {
            get { return (bool)GetValue(SimulateSqlErrorProperty); }
            set { SetValue(SimulateSqlErrorProperty, value); }
        }

        public static readonly DependencyProperty SimulateSqlErrorProperty =
            DependencyProperty.Register("SimulateSqlError", typeof(bool), typeof(ImageArchivalStateMachineWorkflow));


        public bool SimulateCompensatableError
        {
            get { return (bool)GetValue(SimulateCompensatableErrorProperty); }
            set { SetValue(SimulateCompensatableErrorProperty, value); }
        }

        public static readonly DependencyProperty SimulateCompensatableErrorProperty =
            DependencyProperty.Register("SimulateCompensatableError", typeof(bool), typeof(ImageArchivalStateMachineWorkflow));

        public ImageArchivalStateMachineWorkflow()
        {
            InitializeComponent();
        }
    }
}
