﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using WorkflowSimulator;
using System.Collections.Generic;
using MerchantService;

namespace MerchantServiceSequentialWorkflow
{
    [WorkflowSimulationUI(LocalServiceType = "Default", UserInterfaceType = "MerchantService.MerchantServicePanel, MerchantServiceUI")]
    public sealed partial class MerchantServiceSequentialWorkflow : SequentialWorkflowActivity
    {
        public decimal Total
        {
            get { return (decimal)GetValue(TotalProperty); }
            set { SetValue(TotalProperty, value); }
        }

        public static readonly DependencyProperty TotalProperty =
            DependencyProperty.Register("Total", typeof(decimal), typeof(MerchantServiceSequentialWorkflow));

        public List<Item> PurchasedItems
        {
            get { return (List<Item>)GetValue(PurchasedItemsProperty); }
            set { SetValue(PurchasedItemsProperty, value); }
        }

        public static readonly DependencyProperty PurchasedItemsProperty =
            DependencyProperty.Register("PurchasedItems", typeof(List<Item>), typeof(MerchantServiceSequentialWorkflow));

        public string OrderId
        {
            get { return (string)GetValue(OrderIdProperty); }
            set { SetValue(OrderIdProperty, value); }
        }

        public static readonly DependencyProperty OrderIdProperty =
            DependencyProperty.Register("OrderId", typeof(string), typeof(MerchantServiceSequentialWorkflow));

        public bool WaitExpired
        {
            get { return (bool)GetValue(WaitExpiredProperty); }
            set { SetValue(WaitExpiredProperty, value); }
        }

        public static readonly DependencyProperty WaitExpiredProperty =
            DependencyProperty.Register("WaitExpired", typeof(bool), typeof(MerchantServiceSequentialWorkflow));

        public MerchantServiceSequentialWorkflow()
        {
            InitializeComponent();
        }
    }

}
