﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using WorkflowSimulator;

namespace MerchantService
{
    [WorkflowSimulationUI(LocalServiceType = "Default", UserInterfaceType = "MerchantService.MerchantServicePanel, MerchantServiceUI")]
    public sealed partial class MerchantServiceStateMachineWorkflow : StateMachineWorkflowActivity
    {

        public decimal Total
        {
            get { return (decimal)GetValue(TotalProperty); }
            set { SetValue(TotalProperty, value); }
        }

        public static readonly DependencyProperty TotalProperty =
            DependencyProperty.Register("Total", typeof(decimal), typeof(MerchantServiceStateMachineWorkflow));

        public List<Item> PurchasedItems
        {
            get { return (List<Item>)GetValue(PurchasedItemsProperty); }
            set { SetValue(PurchasedItemsProperty, value); }
        }

        public static readonly DependencyProperty PurchasedItemsProperty =
            DependencyProperty.Register("PurchasedItems", typeof(List<Item>), typeof(MerchantServiceStateMachineWorkflow));

        public string OrderId
        {
            get { return (string)GetValue(OrderIdProperty); }
            set { SetValue(OrderIdProperty, value); }
        }

        public static readonly DependencyProperty OrderIdProperty =
            DependencyProperty.Register("OrderId", typeof(string), typeof(MerchantServiceStateMachineWorkflow));


        public MerchantServiceStateMachineWorkflow()
        {
            InitializeComponent();
        }
    }
}
