﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Workflow.Runtime;


namespace MerchantService
{
    /// <summary>
    /// Interaction logic for MerchantServicePanel.xaml
    /// </summary>
    public partial class MerchantServicePanel : UserControl, WorkflowSimulator.IWorkflowUI
    {
        string OrderId { get; set; }

        public WorkflowSimulator.WorkflowDiagram WorkflowDiagram
        {
            get;
            set;
        }

        public MerchantServicePanel()
        {
            InitializeComponent();
        }

        private void btnPurchase_Click(object sender, RoutedEventArgs e)
        {
            if (string.IsNullOrEmpty(OrderId))
            {
                this.OrderId = Guid.NewGuid().ToString();

                List<Item> items = new List<Item>();
                items.Add(new Item() { ItemCost = Decimal.Parse(ItemCost.Text), ItemName = ItemName.Text });

                Dictionary<string, object> initParameters = new Dictionary<string, object>()
                {
                    {"OrderId", this.OrderId},
                    {"PurchasedItems", items},
                    {"Total", items[0].ItemCost}
                };

                WorkflowDiagram.RunWorkflow(initParameters);
            }
            else
            {
                this.WorkflowDiagram.WorkflowInstance.EnqueueItemOnIdle(this.OrderId,
                    new Item() { ItemCost = Decimal.Parse(ItemCost.Text), ItemName = ItemName.Text },
                    null,
                    null); 
            }

        }
    }
}
