﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

namespace SchedulingAssistant
{
    public partial class ProcessFreeBusy : System.Workflow.ComponentModel.Activity
    {
        public AppointmentRequest AppointmentRequest
        {
            get { return (AppointmentRequest)GetValue(AppointmentRequestProperty); }
            set { SetValue(AppointmentRequestProperty, value); }
        }

        public static readonly DependencyProperty AppointmentRequestProperty =
            DependencyProperty.Register("AppointmentRequest", typeof(AppointmentRequest), typeof(ProcessFreeBusy));

        public Attendee Attendee
        {
            get { return (Attendee)GetValue(AttendeeProperty); }
            set { SetValue(AttendeeProperty, value); }
        }

        public static readonly DependencyProperty AttendeeProperty =
            DependencyProperty.Register("Attendee", typeof(Attendee), typeof(ProcessFreeBusy));


        public bool IsFree
        {
            get { return (bool)GetValue(IsFreeProperty); }
            set { SetValue(IsFreeProperty, value); }
        }

        public static readonly DependencyProperty IsFreeProperty =
            DependencyProperty.Register("IsFree", typeof(bool), typeof(ProcessFreeBusy));

        public ProcessFreeBusy()
        {
            InitializeComponent();
        }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            this.IsFree = MasterSchedule.IsFree(Attendee.Name, AppointmentRequest, "ProcessFreeBusy");

            return ActivityExecutionStatus.Closed;
        }
    }
}
