﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

namespace SchedulingAssistant
{
    public partial class SetAllRequiredFreeToFalse : System.Workflow.ComponentModel.Activity
    {
        public bool AreAllRequiredFree
        {
            get { return (bool)GetValue(AreAllRequiredFreeProperty); }
            set { SetValue(AreAllRequiredFreeProperty, value); }
        }

        public static readonly DependencyProperty AreAllRequiredFreeProperty =
            DependencyProperty.Register("AreAllRequiredFree", typeof(bool), typeof(SetAllRequiredFreeToFalse));


        public AppointmentRequest AppointmentRequest
        {
            get { return (AppointmentRequest)GetValue(AppointmentRequestProperty); }
            set { SetValue(AppointmentRequestProperty, value); }
        }

        public static readonly DependencyProperty AppointmentRequestProperty =
            DependencyProperty.Register("AppointmentRequest", typeof(AppointmentRequest), typeof(SetAllRequiredFreeToFalse));

        public Exception NotAllowedException
        {
            get { return (Exception)GetValue(NotAllowedExceptionProperty); }
            set { SetValue(NotAllowedExceptionProperty, value); }
        }

        public static readonly DependencyProperty NotAllowedExceptionProperty =
            DependencyProperty.Register("NotAllowedException", typeof(Exception), typeof(SetAllRequiredFreeToFalse));


        public SetAllRequiredFreeToFalse()
        {
            InitializeComponent();
        }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            Attendee attendee = (from a in AppointmentRequest.Attendees
                                where a.Name == ((CalendarAccessNotAllowedException)NotAllowedException).User
                                select a).First();

            if (attendee.Required)
            {
                AreAllRequiredFree = false;
            }

            return ActivityExecutionStatus.Closed;
        }
    }
}
