﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;

namespace SchedulingAssistant
{
    public partial class SuggestSchedules : System.Workflow.ComponentModel.Activity
    {
        public AppointmentRequest AppointmentRequest
        {
            get { return (AppointmentRequest)GetValue(AppointmentRequestProperty); }
            set { SetValue(AppointmentRequestProperty, value); }
        }

        public static readonly DependencyProperty AppointmentRequestProperty =
            DependencyProperty.Register("AppointmentRequest", typeof(AppointmentRequest), typeof(SuggestSchedules));

        public FreeBusyResults FreeBusyResults
        {
            get { return (FreeBusyResults)GetValue(FreeBusyResultsProperty); }
            set { SetValue(FreeBusyResultsProperty, value); }
        }

        public static readonly DependencyProperty FreeBusyResultsProperty =
            DependencyProperty.Register("FreeBusyResults", typeof(FreeBusyResults), typeof(SuggestSchedules));

        public SuggestSchedules()
        {
            InitializeComponent();
        }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            foreach (Attendee attendee in AppointmentRequest.Attendees)
            {
                MasterSchedule.IsFree(attendee.Name, AppointmentRequest, "SuggestSchedules");
            }
                    
            this.FreeBusyResults = MasterSchedule.SuggestAlternatives(AppointmentRequest);

            return ActivityExecutionStatus.Closed;
        }
    }
}
