﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using WorkflowSimulator;

namespace SchedulingAssistant
{
    [WorkflowSimulationUI(LocalServiceType = "Default", UserInterfaceType = "SchedulingAssistant.SchedulingAssistantPanel, SchedulingAssistantUI")]
    public sealed partial class SchedulingAssistantStateMachine : StateMachineWorkflowActivity
    {
        public AppointmentRequest AppointmentRequest
        {
            get { return (AppointmentRequest)GetValue(AppointmentRequestProperty); }
            set { SetValue(AppointmentRequestProperty, value); }
        }

        public static readonly DependencyProperty AppointmentRequestProperty =
            DependencyProperty.Register("AppointmentRequest", typeof(AppointmentRequest), typeof(SchedulingAssistantStateMachine));

        public bool AllRequiredAttendeesAreFree
        {
            get { return (bool)GetValue(AllRequiredAttendeesAreFreeProperty); }
            set { SetValue(AllRequiredAttendeesAreFreeProperty, value); }
        }

        public static readonly DependencyProperty AllRequiredAttendeesAreFreeProperty =
            DependencyProperty.Register("AllRequiredAttendeesAreFree", typeof(bool), typeof(SchedulingAssistantStateMachine));

        public FreeBusyResults FreeBusyResults
        {
            get { return (FreeBusyResults)GetValue(FreeBusyResultsProperty); }
            set { SetValue(FreeBusyResultsProperty, value); }
        }

        public static readonly DependencyProperty FreeBusyResultsProperty =
            DependencyProperty.Register("FreeBusyResults", typeof(FreeBusyResults), typeof(SchedulingAssistantStateMachine));

        public SchedulingAssistantStateMachine()
        {
            InitializeComponent();
        }

        protected override void InitializeProperties()
        {
            base.InitializeProperties();

            AllRequiredAttendeesAreFree = true;
        }

        private void InitProcessFreeBusyActivity(object sender, ReplicatorChildEventArgs e)
        {
            ProcessFreeBusy processFreeBusy = e.Activity as ProcessFreeBusy;
            processFreeBusy.Attendee = e.InstanceData as Attendee;
        }

        private void FinishProcessFreeBusyActivity(object sender, ReplicatorChildEventArgs e)
        {
            ProcessFreeBusy processFreeBusy = e.Activity as ProcessFreeBusy;
            if (!processFreeBusy.IsFree && processFreeBusy.Attendee.Required)
            {
                this.AllRequiredAttendeesAreFree = false;
            }
        }

        private void AreAllRequiredAttendeesFree(object sender, ConditionalEventArgs e)
        {
            e.Result = this.AllRequiredAttendeesAreFree;
        }

        private void ProcessAllSchedulesComplete(object sender, ConditionalEventArgs e)
        {
            e.Result = (!this.AllRequiredAttendeesAreFree) || ((ReplicatorActivity)sender).AllChildrenComplete;
        }
    }
}
